//+------------------------------------------------------------------+
//|                                           test_count_click_1.mq5 |
//|                                                2016, Dina Paches |
//|                           https://login.mql5.com/ru/users/dipach |
//+------------------------------------------------------------------+
#property copyright "2016, Dina Paches"
#property link      "https://login.mql5.com/ru/users/dipach"
#property version   "1.23"
#property indicator_chart_window
#property indicator_plots   0
//---
#include <ObjectCreateAndSet.mqh>
/*    .  :
https://www.mql5.com/ru/forum/63951/page2#comment_1908129*/
#define TEST_PRINT_ONE(x)          Print(__LINE__,", ",__FUNCTION__,", ",(#x)," = ",(x))
#define TEST_PRINT_TWO(x,y)        Print(__LINE__,", ",__FUNCTION__,", ",(#x)," = ",(x),", ",(#y)," = ",(y))
#define TEST_PRINT_THREE(x,y,z)    Print(__LINE__,", ",__FUNCTION__,", ",(#x)," = ",(x),", ",(#y)," = ",(y),", ",(#z)," = ",(z))
//---
#define NAME_INDICATOR             "count_click_1: "
#define QUANT_OBJ                  (6)// 
#define NUMBER_ALL                 ((QUANT_OBJ/2)-1)//    
#define X_DISTANCE                 (10) 
#define Y_DISTANCE                 (10)
#define WIDTH                      (60)
#define HEIGHT                     (20)
#define FONT_SIZE                  (9)
#define CLR_PANEL                  clrSilver//  
#define CLR_BORDER                 clrLavender// 
#define CORNER_PANEL               CORNER_RIGHT_UPPER
//---
int findPrefixObject,countClick[NUMBER_ALL+1],flagAntivandal;
string prefixObj,textObj[QUANT_OBJ],nameObj[QUANT_OBJ],
textDelInd[2];
//---  :
color clrText[NUMBER_ALL+1]={clrDarkGreen,clrBrown,C'39,39,39'};
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
/* ,      , 
          
 :*/
   flagAntivandal=-1;
/*          
OnChartEvent():*/
   findPrefixObject=-1;
//---          :
   StringConcatenate(prefixObj,NAME_INDICATOR,Symbol(),"_",
                     EnumToString(Period()));
//---    :
   IndicatorSetString(INDICATOR_SHORTNAME,prefixObj);
//---   ,      :
   LanguageTerminal();
//---   : 
   NameObjectPanel(QUANT_OBJ,nameObj,prefixObj,"i");
//---        
   ArrayInitialize(countClick,0);
//---    :
   for(int i=NUMBER_ALL;i>=0;i--){textObj[i]="0";}
//---  :
   PanelCreate();
/*    
     :*/
   flagAntivandal=0;
//---       
   bool res=true;
   ChartEventObjectDeleteGet(res);
   if(res!=true)
     {ChartEventObjectDeleteSet(true);}
//---
   EventSetTimer(5);
//--- 
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   flagAntivandal=-1;
   TEST_PRINT_ONE(flagAntivandal);
//---    :
   ObjectsDeleteAll(0,prefixObj,0,-1);
//---
   EventKillTimer();
//---  ,   OnInit() REASON_INITFAILED.
   if(reason==REASON_INITFAILED)
     {
      ChIndicatorDelete(prefixObj,textDelInd[0],textDelInd[1],0,0);
     }
//---
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---       
   bool res=true;
   ChartEventObjectDeleteGet(res);
   if(res!=true)
     {ChartEventObjectDeleteSet(true);}

  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+ 
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
/*       ,  
,          . 
           
    :*/
      findPrefixObject=StringFind(sparam,prefixObj);
      //---
      if(findPrefixObject==0)
        {
         string clickedChartObject=sparam;
         findPrefixObject=-1;
         //---
         for(int i=QUANT_OBJ-2;i>=0;i--)
           {
/*     ,   :*/
            if(StringCompare(clickedChartObject,nameObj[i],true)==0)
              {
               int count=0,index=-1;
               //,          :
               if(i==4|| i==1)//if "No"
                 {
                  index=1;
                  count=countClick[index]-1;
                 }
               else if(i==3 || i==0)//if "Yes"
                 {
                  index=0;
                  count=countClick[index]+1;
                 }
               else {return;}//,     
               //--- 
               int summ=countClick[NUMBER_ALL]+1;
               //---     :
               countClick[index]=count;
               countClick[NUMBER_ALL]=summ;
               //---     :
               textObj[index]=IntegerToString(count);
               textObj[NUMBER_ALL]=IntegerToString(summ);
               //---     :
               ObSetString(0,nameObj[index],OBJPROP_TEXT,textObj[index]);
               ObSetString(0,nameObj[NUMBER_ALL],OBJPROP_TEXT,textObj[NUMBER_ALL]);
               //---        :
               ChartRedraw();
               return;
              }// if(StringCompare(clickedChartObject,nameObj[i],true)==0)
           }//for(int i=QUANT_OBJ-2;i>=0;i--)
         return;
        }//if(findPrefixObject==0)
      return;
     }//if(id==CHARTEVENT_OBJECT_CLICK)
//+------------------------------------------------------------------+
//|             |
//| CHARTEVENT_OBJECT_CHANGE                                         |
//|     (       |
//|  CHART_EVENT_OBJECT_DELETE=true)                         |
//+------------------------------------------------------------------+
   else  if(id==CHARTEVENT_OBJECT_DELETE || id==CHARTEVENT_OBJECT_CHANGE)
     {
      if(flagAntivandal==-1)// ,  " "
        {
         TEST_PRINT_THREE(id,sparam,flagAntivandal);
         return;
        }
      else if(flagAntivandal==0)// "" 
        {
         //---    :
         findPrefixObject=StringFind(sparam,prefixObj);
         if(findPrefixObject==0)//    
           {
            string chartObject=sparam;
            findPrefixObject=-1;
            //---
            for(int i=QUANT_OBJ-1;i>=0;i--)
              {
               //---     :
               if(StringCompare(chartObject,nameObj[i],true)==0)
                 {
                  TEST_PRINT_TWO(i,chartObject);
                  //---  ,     :
                  flagAntivandal=-1;
                  //---    :
                  ChIndicatorDelete(prefixObj,textDelInd[0],textDelInd[1],0,0);
                  //---
                  ChartRedraw();
                  return;
                 }
              }//for(int i=QUANT_OBJ-1;i>=0;i--)
            return;
           }//if(findPrefixObject==0)
         return;
        }//if(flagAntivandal==0)
      return;
     }//if(id==CHARTEVENT_OBJECT_DELETE || id==CHARTEVENT_OBJECT_CHANGE)  
   return;
  }//void OnChartEvent
//+------------------------------------------------------------------+
//|   ,          |
//| :                                                       |
//+------------------------------------------------------------------+
void LanguageTerminal()
  {
   string language_t=NULL;
   language_t=TerminalInfoString(TERMINAL_LANGUAGE);
//---
   if(language_t=="Russian")
     {
      textObj[3]=": ";
      textObj[4]=": ";
      textObj[5]=": ";
      //---
      StringConcatenate(textDelInd[0],"   : \"",
                        prefixObj,"\".  : ");
      StringConcatenate(textDelInd[1],"   : \"",
                        prefixObj,"\".");
     }
   else
     {
      textObj[3]="Yes: ";
      textObj[4]="No: ";
      textObj[5]="All: ";
      //---
      StringConcatenate(textDelInd[0],"Failed to delete indicator: \"",
                        prefixObj,"\". Error code: ");
      StringConcatenate(textDelInd[1],
                        "Withdrew from chart indicator: \"",
                        prefixObj,"\".");
     }
//---
   return;
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void NameObjectPanel(int quant,// 
                     string &name[],
                     const string prefix,
                     const string dt)//-
  {
   string text=NULL;
//---
   for(int x=0;x<quant;x++)
     {
      StringConcatenate(text,prefix,"_",dt,"_",IntegerToString(x));
      name[x]=text;
     }
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void PanelCreate(const long chart_ID=0,const int sub_window=0)
  {
   for(int i=NUMBER_ALL;i>=0;i--)
     {
      //---     :
      if(ObjectFind(chart_ID,nameObj[i])<0)
        {
         EditCreate(chart_ID,nameObj[i],sub_window,X_DISTANCE+WIDTH,
                    Y_DISTANCE+(HEIGHT)*(i),WIDTH,HEIGHT,
                    textObj[i],"Arial",FONT_SIZE,"\n",ALIGN_RIGHT,true,
                    CORNER_PANEL,clrText[i],CLR_PANEL,CLR_BORDER);
        }
     }
//---
   int correct=NUMBER_ALL+1;
//---
   for(int i=QUANT_OBJ-1;i>=correct;i--)
     {
      //---    :
      if(ObjectFind(chart_ID,nameObj[i])<0)
        {
         EditCreate(chart_ID,nameObj[i],sub_window,X_DISTANCE+(WIDTH*2),
                    Y_DISTANCE+(HEIGHT)*(i-correct),WIDTH,HEIGHT,
                    textObj[i],"Arial",FONT_SIZE,"\n",ALIGN_LEFT,true,
                    CORNER_PANEL,clrText[i-correct],CLR_PANEL,CLR_BORDER);
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|        |
//|  mql5-   ?                          |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /   /                     |
//+------------------------------------------------------------------+
bool ChartEventObjectDeleteGet(bool &result,const long chart_ID=0,
                               const int sub_window=0)
  {
//---      
   long value;
//---   
   ResetLastError();
//---   
   if(!ChartGetInteger(chart_ID,CHART_EVENT_OBJECT_DELETE,sub_window,value))
     {
      //---       ""
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
//---      
   result=value;
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|  /         |
//|     mql5-       |
//| .                                                         |
//+------------------------------------------------------------------+
//|  MQL5 /  ,   |
//| /   /                     |
//+------------------------------------------------------------------+
bool ChartEventObjectDeleteSet(const bool value,const long chart_ID=0,
                               const int sub_window=0)
  {
//---   
   ResetLastError();
//---   
   if(!ChartSetInteger(chart_ID,CHART_EVENT_OBJECT_DELETE,sub_window,value))
     {
      //---       ""
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                               |
//|   ,  :                               |
//|(      = 0(1970.01.01 00:00:00)|
//| 2015 ( : 09.09.2015), Dina Paches              |
//| https://login.mql5.com/ru/users/dipach                           |
//+------------------------------------------------------------------+
//|      :                     |
//| http://book.mql4.com/ru/functions/strings                        |
//| http://forum.mql4.com/ru/56236/page323#877513                    |
//| http://forum.mql4.com/ru/46980/page423#703533                    |
//+------------------------------------------------------------------+
void ObDelCreateTimeExcept0(datetime &create_time,//  
                            long chart_ID=0,//  
                            int sub_window=-1,//  
                            ENUM_OBJECT type=-1)// -1 =   
  {
/*  ,    = 0(1970.01.01 00:00:00),
       ,    
 ,       
  :*/
   if(create_time==0){return;}
   int quant_obj=0;
   quant_obj=ObjectsTotal(chart_ID,sub_window,type);
//---
   if(quant_obj>0)
     {
      datetime create_time_x=0;
      string obj_name=NULL;
      //---
      for(int i=quant_obj-1;i>=0;i--)
        {
         obj_name=ObjectName(chart_ID,i,sub_window,type);
         create_time_x=(datetime)ObjectGetInteger(chart_ID,
                        obj_name,OBJPROP_CREATETIME);
         //---
         if(create_time_x==create_time)
           {ObDelete(chart_ID,obj_name);}
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void ChIndicatorDelete(const string short_name,//  
                       const string &text_0,//     
                       const string &text_1,//   
                       const long  chart_id=0,//  
                       const int   sub_window=-1//  
                       )
  {
   bool res=ChartIndicatorDelete(chart_id,sub_window,short_name);
//---
   if(!res){Print(LINE_NUMBER,text_0,GetLastError());}
   else Print(LINE_NUMBER,text_1);
  }
//+------------------------------------------------------------------+
